Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3863)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3864)
@@ -25,4 +25,11 @@
 ! -----------------
 ! $Id$
+! Modifications made for salsa:
+! - salsa_prognostic_equations moved to salsa_mod (and the call to 
+!   module_interface_mod)
+! - Renamed nbins --> nbins_aerosol, ncc_tot --> ncomponents_mass and 
+!   ngast --> ngases_salsa and loop indices b, c and sg to ib, ic and ig
+! 
+! 3840 2019-03-29 10:35:52Z knoop
 ! added USE chem_gasphase_mod for nvar, nspec and spc_names
 ! 
@@ -376,5 +383,5 @@
     USE buoyancy_mod,                                                          &
         ONLY:  buoyancy
-           
+
     USE chem_modules,                                                          &
         ONLY:  call_chem_at_all_substeps, chem_gasphase_on, cs_name,           &
@@ -447,14 +454,14 @@
                skip_time_do_radiation
 #endif
-                          
+
     USE salsa_mod,                                                             &
-        ONLY:  aerosol_mass, aerosol_number, dt_salsa, last_salsa_time, nbins, &
-               ncc_tot, ngast, salsa_boundary_conds, salsa_diagnostics,        &
-               salsa_driver, salsa_gas, salsa_gases_from_chem, salsa_tendency, &
-               skip_time_do_salsa
-               
+        ONLY:  aerosol_mass, aerosol_number, dt_salsa, last_salsa_time,        &
+               nbins_aerosol, ncomponents_mass, ngases_salsa,                  &
+               salsa_boundary_conds, salsa_diagnostics, salsa_driver,          &
+               salsa_gas, salsa_gases_from_chem, skip_time_do_salsa
+
     USE salsa_util_mod,                                                        &
-        ONLY:  sums_salsa_ws_l                              
-    
+        ONLY:  sums_salsa_ws_l
+
     USE statistics,                                                            &
         ONLY:  hom
@@ -506,10 +513,11 @@
 
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  b                   !< index for aerosol size bins (salsa)
-    INTEGER(iwp) ::  c                   !< index for chemical compounds (salsa)
-    INTEGER(iwp) ::  g                   !< index for gaseous compounds (salsa)
+
     INTEGER(iwp) ::  i                   !<
     INTEGER(iwp) ::  i_omp_start         !<
+    INTEGER(iwp) ::  ib                  !< index for aerosol size bins (salsa)
+    INTEGER(iwp) ::  ic                  !< index for chemical compounds (salsa)
+    INTEGER(iwp) ::  icc                 !< additional index for chemical compounds (salsa)
+    INTEGER(iwp) ::  ig                  !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  j                   !<
     INTEGER(iwp) ::  k                   !<
@@ -587,5 +595,5 @@
        CALL cpu_log( log_point_s(84), 'chem.exch-horiz', 'stop' )
 
-    ENDIF       
+    ENDIF
 !
 !-- Run SALSA and aerosol dynamic processes. SALSA is run with a longer time 
@@ -593,10 +601,10 @@
 !-- concentrations of aerosol number and mass 
     IF ( salsa )  THEN
-       
-       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN                 
+
+       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
           IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
           THEN
              CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
-             !$OMP PARALLEL PRIVATE (i,j,b,c,g)
+             !$OMP PARALLEL PRIVATE (i,j,ib,ic,icc,ig)
              !$OMP DO
 !
@@ -609,5 +617,5 @@
                 ENDDO
              ENDDO
-             
+
              CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
              
@@ -615,21 +623,21 @@
 !
 !--          Exchange ghost points and decycle if needed.
-             DO  b = 1, nbins
-                CALL exchange_horiz( aerosol_number(b)%conc, nbgp )
-                CALL salsa_boundary_conds( aerosol_number(b)%conc_p,           &
-                                           aerosol_number(b)%init )
-                DO  c = 1, ncc_tot
-                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc, nbgp )
-                   CALL salsa_boundary_conds(                                  &
-                                           aerosol_mass((c-1)*nbins+b)%conc_p, &
-                                           aerosol_mass((c-1)*nbins+b)%init )
-                ENDDO
-             ENDDO
-             
+             DO  ib = 1, nbins_aerosol
+                CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
+                CALL salsa_boundary_conds( aerosol_number(ib)%conc,            &
+                                           aerosol_number(ib)%init )
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
+                   CALL salsa_boundary_conds( aerosol_mass(icc)%conc,          &
+                                              aerosol_mass(icc)%init )
+                ENDDO
+             ENDDO
+
              IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  g = 1, ngast
-                   CALL exchange_horiz( salsa_gas(g)%conc, nbgp )
-                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p,             &
-                                              salsa_gas(g)%init )
+                DO  ig = 1, ngases_salsa
+                   CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
+                   CALL salsa_boundary_conds( salsa_gas(ig)%conc,              &
+                                              salsa_gas(ig)%init )
                 ENDDO
              ENDIF
@@ -638,9 +646,9 @@
              !$OMP END PARALLEL
              last_salsa_time = time_since_reference_point
-             
-          ENDIF
-          
-       ENDIF
-       
+
+          ENDIF
+
+       ENDIF
+
     ENDIF 
 
@@ -1442,56 +1450,6 @@
                                      chem_species(lsp)%diss_l_cs )       
              ENDDO
-          
+
           ENDIF   ! Chemical equations
-       
-          IF ( salsa )  THEN 
-!
-!--          Loop over aerosol size bins: number and mass bins
-             IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
-             
-                DO  b = 1, nbins                
-                   sums_salsa_ws_l = aerosol_number(b)%sums_ws_l
-                   CALL salsa_tendency( 'aerosol_number',                      &
-                                         aerosol_number(b)%conc_p,             &
-                                         aerosol_number(b)%conc,               &
-                                         aerosol_number(b)%tconc_m,            &
-                                         i, j, i_omp_start, tn, b, b,          &
-                                         aerosol_number(b)%flux_s,             &
-                                         aerosol_number(b)%diss_s,             &
-                                         aerosol_number(b)%flux_l,             &
-                                         aerosol_number(b)%diss_l,             &
-                                         aerosol_number(b)%init )
-                   aerosol_number(b)%sums_ws_l = sums_salsa_ws_l
-                   DO  c = 1, ncc_tot
-                      sums_salsa_ws_l = aerosol_mass((c-1)*nbins+b)%sums_ws_l 
-                      CALL salsa_tendency( 'aerosol_mass',                     &
-                                            aerosol_mass((c-1)*nbins+b)%conc_p,&
-                                            aerosol_mass((c-1)*nbins+b)%conc,  &
-                                            aerosol_mass((c-1)*nbins+b)%tconc_m,&
-                                            i, j, i_omp_start, tn, b, c,       &
-                                            aerosol_mass((c-1)*nbins+b)%flux_s,&
-                                            aerosol_mass((c-1)*nbins+b)%diss_s,&
-                                            aerosol_mass((c-1)*nbins+b)%flux_l,&
-                                            aerosol_mass((c-1)*nbins+b)%diss_l,&
-                                            aerosol_mass((c-1)*nbins+b)%init )
-                      aerosol_mass((c-1)*nbins+b)%sums_ws_l = sums_salsa_ws_l
-                   ENDDO
-                ENDDO
-                IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  g = 1, ngast
-                      sums_salsa_ws_l = salsa_gas(g)%sums_ws_l
-                      CALL salsa_tendency( 'salsa_gas', salsa_gas(g)%conc_p,   &
-                                      salsa_gas(g)%conc, salsa_gas(g)%tconc_m, &
-                                      i, j, i_omp_start, tn, g, g,             &
-                                      salsa_gas(g)%flux_s, salsa_gas(g)%diss_s,&
-                                      salsa_gas(g)%flux_l, salsa_gas(g)%diss_l,&
-                                      salsa_gas(g)%init )
-                      salsa_gas(g)%sums_ws_l = sums_salsa_ws_l
-                   ENDDO
-                ENDIF
-             
-             ENDIF
-             
-          ENDIF        
 
        ENDDO  ! loop over j
@@ -1517,8 +1475,9 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  b     !< index for aerosol size bins (salsa)
-    INTEGER(iwp) ::  c     !< index for chemical compounds (salsa)
-    INTEGER(iwp) ::  g     !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  i     !<
+    INTEGER(iwp) ::  ib    !< index for aerosol size bins (salsa)
+    INTEGER(iwp) ::  ic    !< index for chemical compounds (salsa)
+    INTEGER(iwp) ::  icc   !< additional index for chemical compounds (salsa)
+    INTEGER(iwp) ::  ig    !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  j     !<
     INTEGER(iwp) ::  k     !<
@@ -1532,12 +1491,9 @@
 !-- concentrations of aerosol number and mass 
     IF ( salsa )  THEN
-       
        IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
-       
           IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
           THEN
-          
              CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
-             !$OMP PARALLEL PRIVATE (i,j,b,c,g)
+             !$OMP PARALLEL PRIVATE (i,j,ib,ic,icc,ig)
              !$OMP DO
 !
@@ -1550,38 +1506,32 @@
                 ENDDO
              ENDDO
-             
+
              CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
-             
              CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
 !
 !--          Exchange ghost points and decycle if needed.
-             DO  b = 1, nbins
-                CALL exchange_horiz( aerosol_number(b)%conc, nbgp )
-                CALL salsa_boundary_conds( aerosol_number(b)%conc_p,           &
-                                           aerosol_number(b)%init )
-                DO  c = 1, ncc_tot
-                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc, nbgp )
-                   CALL salsa_boundary_conds(                                  &
-                                           aerosol_mass((c-1)*nbins+b)%conc_p, &
-                                           aerosol_mass((c-1)*nbins+b)%init )
-                ENDDO
-             ENDDO
-             
+             DO  ib = 1, nbins_aerosol
+                CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
+                CALL salsa_boundary_conds( aerosol_number(ib)%conc,            &
+                                           aerosol_number(ib)%init )
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
+                   CALL salsa_boundary_conds( aerosol_mass(icc)%conc,          &
+                                              aerosol_mass(icc)%init )
+                ENDDO
+             ENDDO
              IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  g = 1, ngast
-                   CALL exchange_horiz( salsa_gas(g)%conc, nbgp )
-                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p,             &
-                                              salsa_gas(g)%init )
+                DO  ig = 1, ngases_salsa
+                   CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
+                   CALL salsa_boundary_conds( salsa_gas(ig)%conc,              &
+                                              salsa_gas(ig)%init )
                 ENDDO
              ENDIF
              CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
-             
              !$OMP END PARALLEL
              last_salsa_time = time_since_reference_point
-             
-          ENDIF
-          
-       ENDIF
-       
+          ENDIF
+       ENDIF
     ENDIF 
 
@@ -2661,43 +2611,4 @@
        CALL cpu_log( log_point_s(25), 'chem.advec+diff+prog', 'stop' )             
     ENDIF   ! Chemicals equations
-        
-    IF ( salsa )  THEN 
-       CALL cpu_log( log_point_s(92), 'salsa advec+diff+prog ', 'start' )
-!
-!--          Loop over aerosol size bins: number and mass bins
-       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
-       
-          DO  b = 1, nbins                
-             sums_salsa_ws_l = aerosol_number(b)%sums_ws_l
-             CALL salsa_tendency( 'aerosol_number', aerosol_number(b)%conc_p,  &
-                                   aerosol_number(b)%conc,                     &
-                                   aerosol_number(b)%tconc_m,                  &
-                                   b, b, aerosol_number(b)%init )
-             aerosol_number(b)%sums_ws_l = sums_salsa_ws_l
-             DO  c = 1, ncc_tot
-                sums_salsa_ws_l = aerosol_mass((c-1)*nbins+b)%sums_ws_l 
-                CALL salsa_tendency( 'aerosol_mass',                           &
-                                      aerosol_mass((c-1)*nbins+b)%conc_p,      &
-                                      aerosol_mass((c-1)*nbins+b)%conc,        &
-                                      aerosol_mass((c-1)*nbins+b)%tconc_m,     &
-                                      b, c, aerosol_mass((c-1)*nbins+b)%init )
-                aerosol_mass((c-1)*nbins+b)%sums_ws_l = sums_salsa_ws_l
-             ENDDO
-          ENDDO
-          IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  g = 1, ngast
-                sums_salsa_ws_l = salsa_gas(g)%sums_ws_l
-                CALL salsa_tendency( 'salsa_gas', salsa_gas(g)%conc_p,         &
-                                      salsa_gas(g)%conc, salsa_gas(g)%tconc_m, &
-                                      g, g, salsa_gas(g)%init )
-                salsa_gas(g)%sums_ws_l = sums_salsa_ws_l
-             ENDDO
-          ENDIF
-       
-       ENDIF
-       
-       CALL cpu_log( log_point_s(92), 'salsa advec+diff+prog ', 'stop' )
-    ENDIF
-
 
  END SUBROUTINE prognostic_equations_vector
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -26,4 +26,40 @@
 ! -----------------
 ! $Id$
+! Major changes in formatting, performance and data input structure (see branch
+! the history for details)
+! - Time-dependent emissions enabled: lod=1 for yearly PM emissions that are
+!   normalised depending on the time, and lod=2 for preprocessed emissions
+!   (similar to the chemistry module).
+! - Additionally, 'uniform' emissions allowed. This emission is set constant on
+!   all horisontal upward facing surfaces and it is created based on parameters
+!   surface_aerosol_flux, aerosol_flux_dpg/sigmag/mass_fracs_a/mass_fracs_b.
+! - All emissions are now implemented as surface fluxes! No 3D sources anymore.
+! - Update the emission information by calling salsa_emission_update if 
+!   skip_time_do_salsa >= time_since_reference_point and
+!   next_aero_emission_update <= time_since_reference_point
+! - Aerosol background concentrations read from PIDS_DYNAMIC. The vertical grid
+!   must match the one applied in the model.
+! - Gas emissions and background concentrations can be also read in in salsa_mod
+!   if the chemistry module is not applied.
+! - In deposition, information on the land use type can be now imported from
+!   the land use model
+! - Use SI units in PARIN, i.e. n_lognorm given in #/m3 and dpg in metres.
+! - Apply 100 character line limit
+! - Change all variable names from capital to lowercase letter
+! - Change real exponents to integer if possible. If not, precalculate the value
+!   value of exponent
+! - Rename in1a to start_subrange_1a, fn2a to end_subrange_1a etc.
+! - Rename nbins --> nbins_aerosol, ncc_tot --> ncomponents_mass and ngast -->
+!   ngases_salsa
+! - Rename ibc to index_bc, idu to index_du etc.
+! - Renamed loop indices b, c and sg to ib, ic and ig
+! - run_salsa subroutine removed
+! - Corrected a bud in salsa_driver: falsely applied ino instead of inh
+! - Call salsa_tendency within salsa_prognostic_equations which is called in
+!   module_interface_mod instead of prognostic_equations_mod
+! - Removed tailing white spaces and unused variables
+! - Change error message to start by PA instead of SA
+! 
+! 3833 2019-03-28 15:04:04Z forkel
 ! added USE chem_gasphase_mod for nvar, nspec and spc_names 
 ! 
@@ -71,26 +107,20 @@
 ! --------
 ! @author Mona Kurppa (University of Helsinki)
-! 
+!
 !
 ! Description:
 ! ------------
-!> Sectional aerosol module for large scale applications SALSA 
+!> Sectional aerosol module for large scale applications SALSA
 !> (Kokkola et al., 2008, ACP 8, 2469-2483). Solves the aerosol number and mass
-!> concentration as well as chemical composition. Includes aerosol dynamic 
+!> concentration as well as chemical composition. Includes aerosol dynamic
 !> processes: nucleation, condensation/evaporation of vapours, coagulation and
-!> deposition on tree leaves, ground and roofs. 
+!> deposition on tree leaves, ground and roofs.
 !> Implementation is based on formulations implemented in UCLALES-SALSA except
-!> for deposition which is based on parametrisations by Zhang et al. (2001, 
-!> Atmos. Environ. 35, 549-560) or Petroff&Zhang (2010, Geosci. Model Dev. 3, 
+!> for deposition which is based on parametrisations by Zhang et al. (2001,
+!> Atmos. Environ. 35, 549-560) or Petroff&Zhang (2010, Geosci. Model Dev. 3,
 !> 753-769)
 !>
-!> @todo Implement turbulent inflow of aerosols in inflow_turbulence.
-!> @todo Deposition on subgrid scale vegetation 
-!> @todo Deposition on vegetation calculated by default for deciduous broadleaf 
-!>       trees
-!> @todo Revise masked data output. There is a potential bug in case of 
-!>       terrain-following masked output, according to data_output_mask. 
-!> @todo There are now improved interfaces for NetCDF data input which can be
-!>       used instead of get variable etc.
+!> @todo Apply information from emission_stack_height to lift emission sources
+!> @todo emission mode "parameterized", i.e. based on street type
 !------------------------------------------------------------------------------!
  MODULE salsa_mod
@@ -98,5 +128,5 @@
     USE basic_constants_and_equations_mod,                                     &
         ONLY:  c_p, g, p_0, pi, r_d
- 
+
     USE chem_gasphase_mod,                                                     &
         ONLY:  nspec, nvar, spc_names
@@ -113,9 +143,9 @@
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
                nzb_s_inner, nz, nzt, wall_flags_0
-     
+
     USE kinds
-    
+
     USE pegrid
-    
+
     USE salsa_util_mod
 
@@ -125,46 +155,43 @@
 !
 !-- Local constants:
-    INTEGER(iwp), PARAMETER ::  ngast   = 5 !< total number of gaseous tracers:
-                                            !< 1 = H2SO4, 2 = HNO3, 3 = NH3, 
-                                            !< 4 = OCNV (non-volatile OC), 
-                                            !< 5 = OCSV (semi-volatile)  
-    INTEGER(iwp), PARAMETER ::  nmod    = 7 !< number of modes for initialising 
-                                            !< the aerosol size distribution                                              
-    INTEGER(iwp), PARAMETER ::  nreg    = 2 !< Number of main size subranges 
-    INTEGER(iwp), PARAMETER ::  maxspec = 7 !< Max. number of aerosol species
-!    
+    INTEGER(iwp), PARAMETER ::  luc_urban = 8      !< default landuse type for urban: use desert!
+    INTEGER(iwp), PARAMETER ::  ngases_salsa   = 5 !< total number of gaseous tracers:
+                                                   !< 1 = H2SO4, 2 = HNO3, 3 = NH3, 4 = OCNV
+                                                   !< (non-volatile OC), 5 = OCSV (semi-volatile)
+    INTEGER(iwp), PARAMETER ::  nmod    = 7  !< number of modes for initialising the aerosol size
+                                             !< distribution
+    INTEGER(iwp), PARAMETER ::  nreg    = 2  !< Number of main size subranges
+    INTEGER(iwp), PARAMETER ::  maxspec = 7  !< Max. number of aerosol species
+    INTEGER(iwp), PARAMETER ::  season = 1   !< For dry depostion by Zhang et al.: 1 = summer,
+                                             !< 2 = autumn (no harvest yet), 3 = late autumn
+                                             !< (already frost), 4 = winter, 5 = transitional spring
+!
 !-- Universal constants
-    REAL(wp), PARAMETER ::  abo    = 1.380662E-23_wp  !< Boltzmann constant (J/K)
-    REAL(wp), PARAMETER ::  alv    = 2.260E+6_wp      !< latent heat for H2O 
-                                                      !< vaporisation (J/kg)
-    REAL(wp), PARAMETER ::  alv_d_rv  = 4896.96865_wp !< alv / rv
-    REAL(wp), PARAMETER ::  am_airmol = 4.8096E-26_wp !< Average mass of one air
-                                                      !< molecule (Jacobson, 
-                                                      !< 2005, Eq. 2.3)                                                   
-    REAL(wp), PARAMETER ::  api6   = 0.5235988_wp     !< pi / 6   
-    REAL(wp), PARAMETER ::  argas  = 8.314409_wp      !< Gas constant (J/(mol K))
-    REAL(wp), PARAMETER ::  argas_d_cpd = 8.281283865E-3_wp !< argas per cpd
-    REAL(wp), PARAMETER ::  avo    = 6.02214E+23_wp   !< Avogadro constant (1/mol)
-    REAL(wp), PARAMETER ::  d_sa   = 5.539376964394570E-10_wp !< diameter of 
-                                                      !< condensing sulphuric 
-                                                      !< acid molecule (m)  
-    REAL(wp), PARAMETER ::  for_ppm_to_nconc =  7.243016311E+16_wp !< 
-                                                 !< ppm * avo / R (K/(Pa*m3))
+    REAL(wp), PARAMETER ::  abo    = 1.380662E-23_wp   !< Boltzmann constant (J/K)
+    REAL(wp), PARAMETER ::  alv    = 2.260E+6_wp       !< latent heat for H2O
+                                                       !< vaporisation (J/kg)
+    REAL(wp), PARAMETER ::  alv_d_rv  = 4896.96865_wp  !< alv / rv
+    REAL(wp), PARAMETER ::  am_airmol = 4.8096E-26_wp  !< Average mass of one air
+                                                       !< molecule (Jacobson,
+                                                       !< 2005, Eq. 2.3)
+    REAL(wp), PARAMETER ::  api6   = 0.5235988_wp      !< pi / 6
+    REAL(wp), PARAMETER ::  argas  = 8.314409_wp       !< Gas constant (J/(mol K))
+    REAL(wp), PARAMETER ::  argas_d_cpd = 8.281283865E-3_wp  !< argas per cpd
+    REAL(wp), PARAMETER ::  avo    = 6.02214E+23_wp    !< Avogadro constant (1/mol)
+    REAL(wp), PARAMETER ::  d_sa   = 5.539376964394570E-10_wp  !< diameter of condensing sulphuric
+                                                               !< acid molecule (m)
+    REAL(wp), PARAMETER ::  for_ppm_to_nconc =  7.243016311E+16_wp !< ppm * avo / R (K/(Pa*m3))
     REAL(wp), PARAMETER ::  epsoc  = 0.15_wp          !< water uptake of organic
-                                                      !< material     
-    REAL(wp), PARAMETER ::  mclim  = 1.0E-23_wp    !< mass concentration min 
-                                                   !< limit for aerosols (kg/m3)                                                   
-    REAL(wp), PARAMETER ::  n3     = 158.79_wp !< Number of H2SO4 molecules in
-                                               !< 3 nm cluster if d_sa=5.54e-10m
-    REAL(wp), PARAMETER ::  nclim  = 1.0_wp    !< number concentration min limit 
-                                               !< for aerosols and gases (#/m3)
-    REAL(wp), PARAMETER ::  surfw0 = 0.073_wp  !< surface tension of pure water 
-                                               !< at ~ 293 K (J/m2)   
-    REAL(wp), PARAMETER ::  vclim  = 1.0E-24_wp    !< volume concentration min 
-                                                   !< limit for aerosols (m3/m3)                                           
+                                                      !< material
+    REAL(wp), PARAMETER ::  mclim  = 1.0E-23_wp       !< mass concentration min limit (kg/m3)
+    REAL(wp), PARAMETER ::  n3     = 158.79_wp        !< Number of H2SO4 molecules in 3 nm cluster
+                                                      !< if d_sa=5.54e-10m
+    REAL(wp), PARAMETER ::  nclim  = 1.0_wp           !< number concentration min limit (#/m3)
+    REAL(wp), PARAMETER ::  surfw0 = 0.073_wp         !< surface tension of water at 293 K (J/m2)
+!
 !-- Molar masses in kg/mol
     REAL(wp), PARAMETER ::  ambc   = 12.0E-3_wp     !< black carbon (BC)
     REAL(wp), PARAMETER ::  amdair = 28.970E-3_wp   !< dry air
-    REAL(wp), PARAMETER ::  amdu   = 100.E-3_wp     !< mineral dust 
+    REAL(wp), PARAMETER ::  amdu   = 100.E-3_wp     !< mineral dust
     REAL(wp), PARAMETER ::  amh2o  = 18.0154E-3_wp  !< H2O
     REAL(wp), PARAMETER ::  amh2so4  = 98.06E-3_wp  !< H2SO4
